function b = learn_feature_weight(f, b, w, b0, b1, e, e2)

[nfeats,~] = size(w);
u = abs(w);
alpha = 0.03;
beta = 0.8;
e_seq = e;
e_freq = e2;
grad=zeros(length(b),1);

for iter = 1 : 10

   a = calculate_feature_relevance ( f, b0, b1, b );
   preobj = e_seq * b(1)' * b(1) +e_freq*b(2)'*b(2)+ sum( sum( u .* a  ));% - sum(log(a)); %  
   grad(1) = 2 * e_seq * b(1); 
   grad(2) = 2*e_freq*b(2);
   for n = 1 : nfeats
      rel0 = f{n}*b; 
      z2 = sigmoid( rel0 );
     if( u(n) > 0 )	    
 	    const2 = z2 .* ( 1 - z2 );        
        grad = grad+(b1-b0) *f{n}'* u(n) *const2 ;
     end 

   end
   grad2 = grad'* grad;
   t = 0.01;
   for biter = 1 : 100
      new_b = b - t * grad;
      postobj = 0;
      if( length( find( new_b<0 ) )==0 )
         new_a = calculate_feature_relevance ( f, b0, b1, new_b );	 
         postobj =  e_seq * new_b(1)' * new_b(1) +e_freq*new_b(2)'*new_b(2)+ sum( sum( u .* new_a ) );%- sum(log(new_a)); %
         %fprintf('biter:%g t:%g %g %g %g\n',biter,t,preobj,postobj,preobj-alpha*t*grad2);
         if( postobj < preobj - alpha * t * grad2 )
            break;
         else
              t = t * beta;
         end
      else
         t = t * beta;
      end
   end
   if( postobj < preobj )
      b = new_b;
   end
%b',pb
%   if( mod(iter,10)==0 )
   %fprintf('iter = %g\t%g\t%g\tdel = %g\n',iter, preobj, postobj, preobj-postobj);
%   end
   if( abs( preobj-postobj )<0.001 )
      break;
   end
end
end

function a = sigmoid(z)

a = 1.0 ./ (1.0 + exp(z));
end

